
%------------------------------------------------------------------------------
% AFC for Mathworks MATLAB
%
% Version 1.40.0
%
% Author(s): Stephan Ewert
%
% Copyright (c) 1999-2014, Stephan Ewert. 
% All rights reserved.
%
% This work is licensed under the 
% Creative Commons Attribution-NonCommercial-NoDerivs 4.0 International License (CC BY-NC-ND 4.0). 
% To view a copy of this license, visit
% http://creativecommons.org/licenses/by-nc-nd/4.0/ or send a letter to Creative
% Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
%------------------------------------------------------------------------------

% last modified 19-04-2013 11:41:16
% 20-10-2004 08:31

%function gui_localprefs

%global def
%global work
%global msg

colorblk = [0 0 0];
colorwhite = [1 1 1];
colorbase = [0.75 0.75 0.75];
colorstring = [0 0 0];
colordarkblue = [11 10 25]/255;

yPos = 0.875;

fposition = get(0,'defaultFigurePosition');
fposition(1:2) = fposition(1:2)+[fposition(3)-500 fposition(4)-800]/2;
fposition(3:4) = [400 600];

ffontsizetext = 0.177778;
ffontsizecheckbox = 0.355556;

filename = [fileparts(which('afc_main')), filesep, 'autoexec_cfg.m'];
%imagedata = imread('splashscreen3.jpg');

h = figure('BusyAction','cancel',...			% create modal dialog window
   'Tag','gui_localprefs',...
   'menubar','none',...
   'Windowstyle', 'normal',...
   'Interruptible','off',...
   'color',colorbase,...
   ... % added secure close
   ... % added Truetype
   'defaultUIControlFontname','Arial', ...
 ... % SE 14.09.2006 13:08 causes problems in Matlab 5.3  'resize','off', ...
   'numbertitle','off', ...
   ... % change size once to avoid Matlab 6 modal window refresh bug
   'Name','Configure AFC', ...
   'UserData',1,...
   'position',fposition - [0 0 1 1] );
   

% change to default size again
%h = findobj('tag','gui_localprefs');
%set(h,'position',fposition);
   

%c=image(imagedata);
%set(get(c,'parent'),'position',[0 0 1 1],'box','off', ...
%   'xtick',[0 1],'ytick',[0 1],'xticklabel',' | ','yticklabel','      |      ')

% description

c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext*0.1/0.11, ...
	'BusyAction','cancel', ...
	'Position',[0.09 yPos 0.9 0.11], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string',['You have started AFC the first time, have started afc(''setup''), or you have deleted your local preferences in ''' filename '''. Please configure AFC. You may edit your local preferences file any time later. The use of soundmex(pro) is optional.'], ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);
	
%yPos = yPos - 0.11;	
yPos = yPos - 0.12;	
% 64 bit systems
c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.09 yPos 0.9 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string',['32/64-Bit MATLAB on 32/64-Bit Windows Systems:'], ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);

yPos = yPos + 0.03;	
% soundmexPro
b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizecheckbox, ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''localprefs_usesoundmexpro'')', ...
	'Position',[0.09 yPos 0.5 0.05], ...
	'Style','checkbox', ...
	'value',0, ...
	'string','Use soundmexPro', ...
	'selectionhighlight','off', ...
	'backgroundcolor',colorbase,...
   'Tag','localprefs_usesoundmexpro');
   
yPos = yPos - 0.09;	
c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.14 yPos 0.8 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string','Check this box if you have licensed a version of SoundmexPro by Hoertech and would like AFC to use it.', ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);
	
yPos = yPos + 0.01;	
% soundmexPro
b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizecheckbox, ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''localprefs_usesoundmexprofree'')', ...
	'Position',[0.09 yPos 0.5 0.05], ...
	'Style','checkbox', ...
	'value',0, ...
	'string','Use free soundmexPro for AFC', ...
	'selectionhighlight','off', ...
	'backgroundcolor',colorbase,...
   'Tag','localprefs_usesoundmexprofree');
   
yPos = yPos - 0.09;	
c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.14 yPos 0.8 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string','Check this box if you want to use the included free SoundmexPro for AFC by Hoertech.', ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);
   
yPos = yPos - 0.07;	
% 32 bit systems
c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.09 yPos 0.9 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string',['32-Bit MATLAB on 32/64-Bit Windows Systems:'], ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);

yPos = yPos + 0.03;	
% soundmex
b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizecheckbox, ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''localprefs_usesoundmex'')', ...
	'Position',[0.09 yPos 0.5 0.05], ...
	'Style','checkbox', ...
	'value',0, ...
	'string','Use 32-bit soundmex', ...
	'selectionhighlight','off', ...
	'backgroundcolor',colorbase,...
   'Tag','localprefs_usesoundmex2');
   
yPos = yPos - 0.09;	
c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.14 yPos 0.8 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string','Check this box if you have licensed a version of Soundmex or Soundmex2 by Hoertech and would like AFC to use it.', ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);
   
yPos = yPos + 0.01;	   
% soundmexfree
b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizecheckbox, ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''localprefs_usesoundmex'')', ...
	'Position',[0.09 yPos 0.5 0.05], ...
	'Style','checkbox', ...
	'value',0, ...
	'string','Use free version of 32-bit soundmex', ...
	'selectionhighlight','off', ...
	'backgroundcolor',colorbase,...
   'Tag','localprefs_usesoundmexfree');
   
yPos = yPos - 0.09;	 
c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.14 yPos 0.8 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string','Check this box if you have installed Soundmex or Soundmex2 by Hoertech and would like to use the free features.', ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);
   
   
%   
yPos = yPos +0.01;
% soundmexold
b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizecheckbox, ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''localprefs_usesoundmex'')', ...
	'Position',[0.09 yPos 0.5 0.05], ...
	'Style','checkbox', ...
	'value',0, ...
	'string','Use old version of soundmex', ...
	'selectionhighlight','off', ...
	'backgroundcolor',colorbase,...
   'Tag','localprefs_usesoundmex');
   
yPos = yPos - 0.09;
c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.14 yPos 0.8 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string','Check this box if you like to use soundmex 1.18 instead of 2.x.', ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);
   

yPos = yPos - 0.045;	
% All systems
c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.09 yPos 0.9 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string',['All MATLAB versions and systems:'], ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);
   
%   state logging
yPos = yPos + 0.03;   
b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizecheckbox, ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''localprefs_usestatelog'')', ...
	'Position',[0.09 yPos 0.5 0.05], ...
	'Style','checkbox', ...
	'selectionhighlight','off', ...
	'value',0, ...
	'string','Enable state logging', ...
	'backgroundcolor',colorbase,...
   'Tag','localprefs_usestatelog');
   
yPos = yPos - 0.09;  
   c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.14 yPos 0.8 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string','Check this box if you like to monitor a running measurement from a remote computer in the same network.', ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);

yPos = yPos - 0.045; 	
	c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.14 yPos 0.8 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string','Specify the path for the state log file (leave blank to use current working directory):', ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);

yPos = yPos + 0.01; 
e = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
	'BusyAction','cancel', ...
	'Position',[0.14 yPos 0.5 0.04], ...
	'Style','edit', ...
	'selectionhighlight','off', ...
	'string','', ...
	'HorizontalAlignment','left',...
	'backgroundcolor',colorwhite,...
   'Tag','localprefs_statelogpath');

% language
yPos = yPos - 0.12;
c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.09 yPos 0.8 0.1], ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string','Select the default response box language.', ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring);

yPos = yPos - 0.025;   
b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
    'FontSize',ffontsizetext, ...
	'BusyAction','cancel', ...
	'Position',[0.09 yPos 0.5 0.1], ...
	'Style','popupmenu', ...
	'selectionhighlight','off', ...
	'string',{'English','German','French','Danish'}, ...
	'backgroundcolor',colorwhite,...
   'Tag','localprefs_language');
   
   
% buttons 
yPos = yPos - 0.02;    
   b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''localprefs_cancelbutton'')', ...
	'Position',[0.2 yPos 0.2 0.06], ...
	'Style','pushbutton', ...
	'selectionhighlight','off', ...
	'string','Cancel', ...
	'backgroundcolor',colorbase,...
   'Tag','localprefs_cancelbutton');
   
    b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''localprefs_okbutton'')', ...
	'Position',[0.6 yPos 0.2 0.06], ...
	'Style','pushbutton', ...
	'selectionhighlight','off', ...
	'string','Ok', ...
	'backgroundcolor',colorbase,...
   'Tag','localprefs_okbutton');







%pause(5);

%close(h);

%'String','Do not show this message again', ...

% eof