
%------------------------------------------------------------------------------
% AFC for Mathworks MATLAB
%
% Version 1.40.0
%
% Author(s): Stephan Ewert
%
% Copyright (c) 1999-2014, Stephan Ewert. 
% All rights reserved.
%
% This work is licensed under the 
% Creative Commons Attribution-NonCommercial-NoDerivs 4.0 International License (CC BY-NC-ND 4.0). 
% To view a copy of this license, visit
% http://creativecommons.org/licenses/by-nc-nd/4.0/ or send a letter to Creative
% Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
%------------------------------------------------------------------------------

% last modified 18-04-2013 17:49:55
% revision 1.01.2 beta, modified 01.12.2005 14:50

function gui_splashscreen( mode )

global def
%global work
%global msg

colorblk = [0 0 0];
colorbase = [1 1 1];
colorstring = [0 0 0];
colordarkblue = [11 10 25]/255;

fposition = get(0,'defaultFigurePosition');
fposition(1:2) = fposition(1:2)+[fposition(3)-400 fposition(4)-400]/2;
fposition(3:4) = [400 400];

imagedata = imread('gui_splashscreen.jpg');

h = figure('BusyAction','cancel',...			% create modal dialog window
   'Tag','gui_splashscreen',...
   'menubar','none',...
   'Windowstyle', 'modal',...
   'Color',colorblk,...
   'Interruptible','off',...
   ... % added secure close
   ... % added Truetype
   'defaultUIControlFontname','Arial', ...
   'resize','off', ...
   'numbertitle','off', ...
   ... % change size once to avoid Matlab 6 modal window refresh bug
   'Name','About AFC', ...
   'position',fposition - [0 0 1 1] );
   

% change to default size again
set(h,'position',fposition);
   

c=image(imagedata);
set(get(c,'parent'),'position',[0 0 1 1],'box','off', ...
   'xtick',[0 1],'ytick',[0 1],'xticklabel',' | ','yticklabel','      |      ')

b = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''splashscreen_checkbox'')', ...
	'Position',[0.09 0.022 0.03 0.03], ...
	'Style','checkbox', ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring,...
   'Tag','splashscreen_checkbox');

c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''splashscreen_checkbox'')', ...
	'Position',[0.55 0.9 0.3 0.05], ...
	'FontSize',0.75, ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string',def.version, ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring,...
   'Tag','splashscreen_checkbox');

c = uicontrol ...
   ('Parent',h, ...
   'Units','normalized', ...
	'FontUnits','normalized', ...
	'BusyAction','cancel', ...
   'Callback','gui_eventhandler(''splashscreen_checkbox'')', ...
	'Position',[0.55 0.85 0.3 0.05], ...
	'FontSize',0.75, ...
	'Style','text', ...
	'HorizontalAlignment','left',...
	'string',def.versionDate, ...
	'selectionhighlight','off', ...
	'backgroundColor',colorbase,...
	'foregroundColor',colorstring,...
   'Tag','splashscreen_checkbox');



%pause(5);

%close(h);

%'String','Do not show this message again', ...

% eof