
%------------------------------------------------------------------------------
% AFC for Mathworks MATLAB
%
% Version 1.40.0
%
% Author(s): Stephan Ewert
%
% Copyright (c) 1999-2014, Stephan Ewert. 
% All rights reserved.
%
% This work is licensed under the 
% Creative Commons Attribution-NonCommercial-NoDerivs 4.0 International License (CC BY-NC-ND 4.0). 
% To view a copy of this license, visit
% http://creativecommons.org/licenses/by-nc-nd/4.0/ or send a letter to Creative
% Commons, 444 Castro Street, Suite 900, Mountain View, California, 94041, USA.
%------------------------------------------------------------------------------

% last modified 26-03-2014 11:51:32
% revision 1.30.1

function gui_writeautoexec


global work

% SE changed location to afc root folder 26.03.2014 10:51
% filename = [fileparts(which('afc_main')), filesep, 'autoexec_cfg.m'];
filename = [fileparts(which('afc')), filesep, 'autoexec_cfg.m'];

beg = ['% autoexec_cfg generated by Configure AFC. Add your local preferences here.'];

fid = fopen(filename,'w');
   
fprintf(fid,['%s\n'],beg);
fprintf(fid,'\n');

if ( work.localprefs.useSoundmexPro == 1 )
	line = 'def.externSoundCommand = ''soundmexpro'';';
	
	fprintf(fid,['%s\n'],line);
elseif ( work.localprefs.useSoundmexProFree == 1 )
	line = 'def.externSoundCommand = ''soundmexprofree'';';
	
	fprintf(fid,['%s\n'],line);
elseif ( work.localprefs.useSoundmex == 1 )
	line = 'def.externSoundCommand = ''soundmex'';';
	if ( work.localprefs.useSoundmexFree == 1 )
		line = 'def.externSoundCommand = ''soundmexfree'';';
	end
	fprintf(fid,['%s\n'],line);
else
	if ( work.localprefs.useSoundmex2 == 1 )
		line = 'def.externSoundCommand = ''soundmex2'';';
		fprintf(fid,['%s\n'],line);
	elseif ( work.localprefs.useSoundmexFree == 1 )
		line = 'def.externSoundCommand = ''soundmex2free'';';
		fprintf(fid,['%s\n'],line);
	end
	
end

if ( work.localprefs.useStatelog == 1 )
	line = 'def.stateLog = 1;';
	fprintf(fid,['%s\n'],line);
	
	line = ['def.stateLogPath = ''' work.localprefs.statelogPath ''';'];
	fprintf(fid,['%s\n'],line);
end

% language
switch (work.localprefs.language)
case 'English'
	lang = 'EN';
case 'German'
	lang = 'DE';
case 'French'
	lang = 'FR';
case 'Danish'
	lang = 'DA';
otherwise
	lang = 'EN';
end

line = ['def.language = ''' lang ''';'];
fprintf(fid,['%s\n'],line);

		
fclose(fid);


% eof 